//=============================================================================
// Wiznet W5100 EVM Module Test Program
// by nexp76(nexp76@naver.com) http://cafe.naver.com/elab
//
// [tcp1.c]
//=============================================================================

/*
 - [W5100] EVM Tcp Clinent Test Program
 - MY_SOURCE_PORT(3000)  Ͽ   ø ǥ 
*/

#include <string.h>


#include "..\00_hal\system.h"
#include "..\01_drv\serial.h"

#include "../01_drv/wiznet/mcu/types.h"
#include "../01_drv/wiznet/iinchip/w5100.h"
#include "../01_drv/wiznet/iinchip/socket.h"
#include "../01_drv/wiznet/iinchip/wiznet.h"


//-----------------------------------------------------------------------------
#define MY_NET_MAC			"\x00\x08\xDC\x00\x00\x00"		// MY Mac Address : 00.08.DC.00.00.00

#define MY_NET_SIP			0xC0A80003	// MY Source IP     : 192.168.0.3
#define MY_NET_GWIP			0xC0A80001	// MY Gateway IP    : 192.168.0.1
#define MY_CH_DESTIP		0xC0A80002	// MY Destination   : 192.168.0.2

#define MY_NET_SN			0xFFFFFF00	// MY Subnet Mask   : 255.255.255.0
#define MY_NET_DNS			0x00000000	// MY DNS Server IP : 0.0.0.0
#define MY_NET_MEMALLOC		0x55		// MY iinchip memory allocation

#define MY_LISTEN_PORT		5000		// MY Listen Port  : 5000 
#define MY_CONNECT_PORT		3000		// MY Connect Port : 3000
#define MY_SOURCE_PORT		3000		// MY Source Port  : 3000

#define TX_RX_MAX_BUF_SIZE	2048
#define SOCK_TCPC			0
#define SOCK_TCPS			1
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
#define HTONL				_htonl

u_long _htonl(u_long l)
{
	u_long ret=0;
	ret = (l & 0xFF) << 24;
	ret |= ((l >> 8) & 0xFF) << 16;
	ret |= ((l >> 16) & 0xFF) << 8;
	ret |= ((l >> 24) & 0xFF);
	return ret;
}

void NetInit(void)
{
	u_char mac[6];
	unsigned long ip;
	memcpy(mac, MY_NET_MAC, 6);
	
	iinchip_init();

	ip = HTONL(MY_NET_SIP);
	setSIPR((u_char*)&ip);

	ip = HTONL(MY_NET_GWIP);
	setGAR((u_char*)&ip);

	ip = HTONL(MY_NET_SN);

	setSUBR((u_char*)&ip);

	setSHAR(mac);
	
#ifdef __DEF_IINCHIP_INT__
	setIMR(0xEF);
#endif
	
	sysinit(MY_NET_MEMALLOC, MY_NET_MEMALLOC);
}
//-----------------------------------------------------------------------------


unsigned char m_SokStatus1 = 2;
//-----------------------------------------------------------------------------
//ŵ ó
void EthernetTest(unsigned char *pRcvBuffer, unsigned int len)
{
	unsigned int i;


	DebugPrint("Read Data[%d]\r\n", len);
	
	for(i=0;i<len;i++)
	{
		//if(i%16==0)DebugPrint("\r\n");
		DebugPrint("%c", pRcvBuffer[i]);
	}
	DebugPrint("\r\nSend OK!\r\n");
}


//TCP-Client ó
void ProcessTcpClient(void)
{
	unsigned int len;							
	unsigned char data_buf[TX_RX_MAX_BUF_SIZE];
	unsigned long server_ip = HTONL(MY_CH_DESTIP);
	unsigned long port = MY_CONNECT_PORT;
	
	switch (getSn_SR(SOCK_TCPC))
	{
	case SOCK_ESTABLISHED:
		if(m_SokStatus1==1)
		{
			m_SokStatus1 = 2;
		}
		
		//check Rx data
		if((len = getSn_RX_RSR(SOCK_TCPC)) > 0) 			
		{
			//if Rx data size is lager than TX_RX_MAX_BUF_SIZE 
			if (len > TX_RX_MAX_BUF_SIZE) len = TX_RX_MAX_BUF_SIZE;	
			//read the received data
			len = recv(SOCK_TCPC, data_buf, len);			

			//send the received data - loop back test
			//send(SOCK_TCPC, data_buf, len);	

			//Debug serial print
			EthernetTest(data_buf, len);
		}
		break;
		
	case SOCK_CLOSE_WAIT:                           		
		//If the client request to close
		disconnect(SOCK_TCPC);
		
		m_SokStatus1 = 0;
		break;
		
	case SOCK_CLOSED:
		//if a socket is closed
		if(!m_SokStatus1)
		{
			//DebugPrint("TCP Client Started!\r\n");
			m_SokStatus1 = 1;
		}

		//reinitialize the socket
		if(socket(SOCK_TCPC, Sn_MR_TCP, port, 0x00) == 0)    
		{
			m_SokStatus1 = 0;
		}
		else
		{	
			connect(SOCK_TCPC, (unsigned char*)&server_ip, port);
		}		
		break;
	}	
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Main Routine
//-----------------------------------------------------------------------------
int main(void)
{
	SystemInit();
	
	//Serial Init
	DebugInit(BAUD_115200);
	DebugPrint("Wiznet W5100 Test Program..\r\n");

	//W5100 Chip Initialize
	//----------------------------
	InitWiznet();

	NetInit();
	//----------------------------
	
	//Display Net Configuration..
	DisplayConfig();
	
	while (1)
	{
		//TCP Client Process
		ProcessTcpClient();
	}		
}
//-----------------------------------------------------------------------------
